#include <iostream.h>
#include <values.h>
#include <stdlib.h>
#include <math.h>	

// 

class m511
{
  double min,max;
 public:
  m511(){min=-100;max=0;};    //
  double getvalue(double);
  double getmax(){return max;};
  double getmin(){return min;};
  int sign(double x)
  {
    if(x>=0)
      return 1;
    return -1;
  }
  void  setmax(double d){max=d;};
  void  setmin(double d){min=d;};
};


double m511::getvalue(double x)
{
  double r,s,e=0.0001;
  int p=2;
  if(x>max||x<min) return MAXDOUBLE;
  r=x/2;
  double __t=1.0;
  for(int k=1;k<=p;k++)
    __t*=r/k;
  for(k=1,s=__t;fabs(__t)>e;k++)
  {
    __t*=r/(k*(k+p));
    s+=__t;
  }
  return s;
}


class m512
{
  double min,max;
 public:
  m512(){min=0;max=1;};    //
  double getvalue(double);
  int sign(double x)
  {
    if(x>=0)
      return 1;
    return -1;
  }
  double getmax(){return max;};
  double getmin(){return min;};
  void  setmax(double d){max=d;};
  void  setmin(double d){min=d;};
};


double m512::getvalue(double x)
{
  double r=1.0,r1,r2,e=0.000001;
  double p=2;

  if(x>max||x<min)
    return MAXDOUBLE;
  r1=sqrt(1-x);//x<0
  while(r-r1>e)
  {
    r2=(r+r1)/2;
    r1=sqrt(r*r1);
    r=r2;
  }
  return (r+r1)*p-M_PI;
}

class m513
{
  double min,max;
 public:
  m513(){min=1;max=2;};    //
  double getvalue(double);
  int sign(double x)
  {
    if(x>=0)
      return 1;
    return -1;
  }
  double getmax(){return max;};
  double getmin(){return min;};
  void  setmax(double d){max=d;};
  void  setmin(double d){min=d;};
};


double m513::getvalue(double x)
{
  double r,r2,q,y;
  double p=-0.1;
  int n=0,k;

  if(x>max||x<min)
    return MAXDOUBLE;
  y=x;
  n=10.0-x;
  y=x+n;
  r=1.0/y;
  q=r*r;
  r=log(y)-r/2-q/12.0*(1.0-q*(0.1+q/21.0));
  for(k=0;k<n;k++)
    r-=1.0/(x+k);
  return r-p;
}


class m514
{
  double min,max;
 public:
  m514(){min=0.2;max=0.6;};    //
  double getvalue(double);
  double getvalue1(double);
  int sign(double x)
  {
    if(x>=0)
      return 1;
    return -1;
  }
  double getmax(){return max;};
  double getmin(){return min;};
  void  setmax(double d){max=d;};
  void  setmin(double d){min=d;};
};

double m514::getvalue1(double x)
{
  return x-1;
}

double m514::getvalue(double x)
{
  double p1=0.1818,p2=3,q,r,s,t;

  if(x>max||x<min)
    return MAXDOUBLE;
  s=p1;
  t=sqrt(2*x/M_PI);
  r=-4*x*x;
  int k=p2;
  t*=x;
  do
  {
    q=s;
    s-=t/k;
    t*=r/((k+1)*(k+3));
    k+=4;
  }while(s!=q);
  return s;
}


class m515
{
  double min,max;
 public:
  m515(){min=0;max=3.0;};    //
  double getvalue(double);
  double getderive(double);
  int sign(double x)
  {
    if(x>=0)
      return 1;
    return -1;
  }
  double getmax(){return max;};
  double getmin(){return min;};
  void  setmax(double d){max=d;};
  void  setmin(double d){min=d;};
};


double m515::getvalue(double x)
{
  if(x>max||x<min)
    return MAXDOUBLE;
  return x*x*x-2*x-5;
}

double m515::getderive(double x)
{
  double dx=0.000001;

  if(x>max||x<min)
    return MAXDOUBLE;
  return (getvalue(x+dx)-getvalue(x))/dx;
}


class m516
{
  double min,max;
 public:
  m516(){min=0;max=1;};    //
  double getvalue(double);
  int sign(double x)
  {
    if(x>=0)
      return 1;
    return -1;
  }
  double getmax(){return max;};
  double getmin(){return min;};
  void  setmax(double d){max=d;};
  void  setmin(double d){min=d;};
};


double m516::getvalue(double x)
{
  double r=1.0,r1,r2,e=0.000001;
  double p=2;

  if(x>max||x<min)
    return MAXDOUBLE;
  r1=sqrt(1-x);//x<0
  while(r-r1>e)
  {
    r2=(r+r1)/2;
    r1=sqrt(r*r1);
    r=r2;
  }
  return (r+r1)*p-M_PI;
}

/*

void main(void)
{
   m511 test;

   for(double i=test.getmin();i<test.getmax();
		i+=(-test.getmin()+test.getmax())/300)
   {
     cout.width(10);
     cout<<i<<"\t"<<test.getvalue(i)<<endl;
   }
}

*/

/*
void main(void)
{
   m511 test;

   double step=(-test.getmin()+test.getmax())/300;
   for(double i=test.getmin();i<test.getmax();i+=step)
   {
     double f=test.getvalue(i);
     double s=test.getvalue(i+step);
     if(test.sign(f)!=test.sign(s))
     {
       cout.width(10);
       cout<<i<<"\t"<<f<<endl;
       cout.width(10);
       cout<<i+step<<"\t"<<s<<endl;
     }
   }
}

*/

/*

//

void main(void)
{
   m512 test;
   double x,k;

   double c=test.getmin();
   double d=test.getmax();
   double e=0.000001;
   while(fabs(d-c)>e)
   {
     k=0.5;
     x=c+k*(d-c);
     if(test.sign(test.getvalue(c))==test.sign(test.getvalue(x)))
       c=x;
     else
       d=x;
   }
   cout<<"  : "<<(c+d)/2<<endl;
}

*/

/*

// 

void main(void)
{
   m513 test;
   double x,k;

   double c=test.getmin();
   double d=test.getmax();
   double e=0.000001;
   while(fabs(d-c)>e)
   {
     k=test.getvalue(c)/(test.getvalue(c)-test.getvalue(d));
     x=c+k*(d-c);
     if(test.sign(test.getvalue(c))==test.sign(test.getvalue(x)))
       c=x;
     else
       d=x;
   }
   cout<<"  : "<<(c+d)/2<<endl;
}

*/

/*
// 

void main(void)
{
   m514 test;
   double x3,k;

   double x1 =test.getmin();
   double x2=test.getmax();
   double e=0.00000001;
   while(fabs(x3-x2)>e)
   {
     k=test.getvalue(x2)/(test.getvalue(x2)-test.getvalue(x1));
     x3=x2-k*(x2-x1);
     x1=x2;
     x2=x3;
   }
   cout<<"  : "<<x3<<endl;
}

*/

/*

// 

void main(void)
{
   m515 test;
   double x1,x2,k,e=0.00000001;

   x1=x2=(test.getmin()+test.getmax())/2;
   do
   {
     x1=x2;
     k=1/test.getderive(x1);
     x2=x1-test.getvalue(x1)*k;
   }while(fabs(x2-x1)>e);
   cout<<"  : "<<x2<<endl;
}

*/
/*

// 


void main(void)
{
   m516 test;
   double x,k;

   double c=test.getmin();
   double d=test.getmax();
   double e=0.000001;
   while(fabs(d-c)>e)
   {
     k=(long double)rand()/(long double)RAND_MAX;
     x=c+k*(d-c);
     if(test.sign(test.getvalue(c))==test.sign(test.getvalue(x)))
       c=x;
     else
       d=x;
   }
   cout<<"  : "<<(c+d)/2<<endl;
}

*/
