#include <iostream.h>
#include <values.h>
#include <math.h>
#include <windows.h>

//  

class m521
{
  double min,max;
 public:
  m521(){min=0;max=15;};    //
  double getvalue(double);
  int sign(double x)
  {
    if(x>=0)
      return 1;
    return -1;
  }
  double getmax(){return max;};
  double getmin(){return min;};
  void setmax(double d){max=d;};
  void setmin(double d){min=d;};
};


double m521::getvalue(double x)
{
  if(x>max||x<min)
    return MAXDOUBLE;
  return (27.0-2*x*(9.0-x))*exp(-x/3.0);
}


class m522
{
  double min,max;
 public:
  m522(){min=0;max=15;};    //
  double getvalue(double);
  int sign(double x)
  {
    if(x>=0)
      return 1;
    return -1;
  }
  DWORD fib(int);
  double getmax(){return max;};
  double getmin(){return min;};
  void  setmax(double d){max=d;};
  void  setmin(double d){min=d;};
};

DWORD m522::fib(int num)//c 0;
{
  if(num==0||num==1)
    return 1;
  DWORD fpred=1,fpredpred=1,fcur;
  for(int i=2;i<=num;i++)
  {
    fcur=fpred+fpredpred;
    fpredpred=fpred;
    fpred=fcur;
  }
  return fcur;
}


double m522::getvalue(double x)
{
  if(x>max||x<min)
    return MAXDOUBLE;
  return (27.0-2*x*(9.0-x))*exp(-x/3.0);
}


class m523
{
  double min,max;
 public:
  m523(){min=0;max=15;};    //
  int sign(double x)
  {
    if(x>=0)
      return 1;
    return -1;
  }
  double getvalue(double);
  double getmax(){return max;};
  double getmin(){return min;};
  void  setmax(double d){max=d;};
  void  setmin(double d){min=d;};
};


double m523::getvalue(double x)
{
  if(x>max||x<min)
    return MAXDOUBLE;
  return (27.0-2*x*(9.0-x))*exp(-x/3.0);
}


class m524
{
  double minx1,maxx1,minx2,maxx2;
 public:
  m524(){minx1=-1;maxx1=0;minx2=0;maxx2=1;};    //
  double getvalue(double,double);
  double getmaxx1(){return maxx1;};
  double getminx1(){return minx1;};
  int sign(double x)
  {
    if(x>=0)
      return 1;
    return -1;
  }
  void  setmaxx1(double d){maxx1=d;};
  void  setminx1(double d){minx1=d;};
  double getmaxx2(){return maxx2;};
  double getminx2(){return minx2;};
  void  setmaxx2(double d){maxx2=d;};
  void  setminx2(double d){minx2=d;};
};


double m524::getvalue(double x1,double x2)
{
  if(x1>maxx1||x1<minx1||x2>maxx2||x2<minx2)
    return MAXDOUBLE;
  return exp(x1*x1+x2*x2)+2*x1-3.5*x2;
}


class m525
{
  double minx1,maxx1,minx2,maxx2;
  int r;
 public:
  m525(){minx1=-1;maxx1=0;minx2=0;maxx2=1;r=2;};    //
  double getvalue(double*);
  int getrange(){return r;};
  double getmax(int);
  double getmin(int);
  void setmax(int,double d);
  void setmin(int,double d);
  int sign(double x)
  {if(x>=0) return 1;return -1;}
};

void m525::setmax(int i,double d)
{ if(!i) maxx1=d;  else maxx2=d;}

void m525::setmin(int i,double d)
{if(!i) minx1=d; else minx2=d;
}

double m525::getmax(int i)
{if(!i) return maxx1;  return maxx2;}

double m525::getmin(int i)
{
  if(!i) return minx1; return minx2;}

double m525::getvalue(double *x)
{
//  if(x[0]>maxx1||x[0]<minx1||x[1]>maxx2||x[1]<minx2)
  //  return MAXDOUBLE;
  return exp(x[0]*x[0]+x[1]*x[1])+2*x[0]-3.5*x[1];
}


class m526
{
  double minx1,maxx1,minx2,maxx2;
 public:
  m526(){minx1=-1;maxx1=0;minx2=0;maxx2=1;};    //
  double getvalue(double,double);
  int sign(double x)
  {
    if(x>=0)
      return 1;
    return -1;
  }
  double getmaxx1(){return maxx1;};
  double getminx1(){return minx1;};
  void  setmaxx1(double d){maxx1=d;};
  void  setminx1(double d){minx1=d;};
  double getmaxx2(){return maxx2;};
  double getminx2(){return minx2;};
  void  setmaxx2(double d){maxx2=d;};
  void  setminx2(double d){minx2=d;};
};


double m526::getvalue(double x1,double x2)
{
    if(x1>maxx1||x1<minx1||x2>maxx2||x2<minx2)
    return MAXDOUBLE;
  return exp(x1*x1+x2*x2)+2*x1-3.5*x2;
}

/*

//One-half division

void main(void)
{
   m521 test;
   double x,l,r,e=0.0000001;

   double c=test.getmin();
   double d=test.getmax();
   while(fabs(d-c)>e)
   {
     x=(c+d)/2;
     l=(c+x)/2;
     r=(x+d)/2;
     if(test.sign(test.getvalue(r)-test.getvalue(l))<0)
       c=l;
     else
       d=r;
   }
   cout<<" : "<<x<<"\t"<<test.getvalue(x)<<endl;
   c=test.getmin();
   d=test.getmax();
   while(fabs(d-c)>e)
   {
     x=(c+d)/2;
     l=(c+x)/2;
     r=(x+d)/2;
     if(test.sign(test.getvalue(r)-test.getvalue(l))>0)
       c=l;
     else
       d=r;
   }
   cout<<" : "<<x<<"\t"<<test.getvalue(x)<<endl;
}
*/

/*

// 

void main(void)
{
   m522 test;
   double k,x1,x2;
   int n=40;

   double c=test.getmin();
   double d=test.getmax();
   for(int i=n;i>1;i--)
   {
     k=(test.fib(i-2)+pow(-1,i)*e)/test.fib(i);
     x1=c+k*(d-c);
     x2=d-k*(d-c);
     if(test.sign(test.getvalue(x1)-test.getvalue(x2))>0)
       c=x1;
     else
       d=x2;
   }
   cout<<" : "<<(c+d)/2<<"\t"<<test.getvalue((c+d)/2)<<endl;
   c=test.getmin();
   d=test.getmax();
   for(i=n;i>1;i--)
   {
     k=(test.fib(i-2)+pow(-1,i)*e)/test.fib(i);
     x1=c+k*(d-c);
     x2=d-k*(d-c);
     if(test.sign(test.getvalue(x1)-test.getvalue(x2))<0)
       c=x1;
     else
       d=x2;
   }
   cout<<" : "<<(c+d)/2<<"\t"<<test.getvalue((c+d)/2)<<endl;
}

*/

/*

//  

void main(void)
{
   m523 test;
   double x,l,r,e=0.0000001;

   double k=0.618033989;
   double c=test.getmin();
   double d=test.getmax();
   while(fabs(d-c)>e)
   {
     x=(c+d)/2;
     l=c+k*(d-c);
     r=d-k*(d-c);
     if(test.sign(test.getvalue(r)-test.getvalue(l))>0)
       c=l;
     else
       d=r;
   }
   cout<<" : "<<(c+d)/2<<"\t"<<test.getvalue((c+d)/2)<<endl;
   c=test.getmin();
   d=test.getmax();
   while(fabs(d-c)>e)
   {
     x=(c+d)/2;
     l=c+k*(d-c);
     r=d-k*(d-c);
     if(test.sign(test.getvalue(r)-test.getvalue(l))<0)
       c=l;
     else
       d=r;
   }
   cout<<" : "<<(c+d)/2<<"\t"<<test.getvalue((c+d)/2)<<endl;
}
*/

/*
//  

void main(void)
{
   m524 test;
   double x1,x2,l1,l2,r1,r2,e=0.0000001;
   double k=0.5618033989;
   double c1=x1=test.getminx1();
   double c2=x2=test.getminx2();
   double d1=test.getmaxx1();
   double d2=test.getmaxx2();
   double dx1,dx2;
   while(fabs(dx1)>e||fabs(dx2)>e)
   {
     c1=test.getminx1();
     c2=test.getminx2();
     d1=test.getmaxx1();
     d2=test.getmaxx2();
     while(fabs(d1-c1)>e)
     {
       l1=c1+k*(d1-c1);
       r1=d1-k*(d1-c1);
       if(test.sign(test.getvalue(r1,x2)-test.getvalue(l1,x2))>0)
         c1=l1;
       else
         d1=r1;
     }
     dx1=x1-(c1+d1)/2;
     x1=(c1+d1)/2;
     while(fabs(d2-c2)>e)
     {
       l2=c2+k*(d2-c2);
       r2=d2-k*(d2-c2);
       if(test.sign(test.getvalue(x1,r2)-test.getvalue(x1,l2))>0)
         c2=l2;
       else
         d2=r2;
     }
     dx2=x2-(c2+d2)/2;
     x2=(c2+d2)/2;
   }
   cout<<" : "<<x1<<"\t"<<x2<<"\t"<<test.getvalue(x1,x2)<<endl;
   c1=x1=test.getminx1();
   c2=x2=test.getminx2();
   d1=test.getmaxx1();
   d2=test.getmaxx2();
   while(fabs(dx1)>e||fabs(dx2)>e)
   {
     c1=test.getminx1();
     c2=test.getminx2();
     d1=test.getmaxx1();
     d2=test.getmaxx2();
     while(fabs(d1-c1)>e)
     {
       l1=c1+k*(d1-c1);
       r1=d1-k*(d1-c1);
       if(test.sign(test.getvalue(r1,x2)-test.getvalue(l1,x2))<0)
         c1=l1;
       else
         d1=r1;
     }
     dx1=x1-(c1+d1)/2;
     x1=(c1+d1)/2;
     while(fabs(d2-c2)>e)
     {
       l2=c2+k*(d2-c2);
       r2=d2-k*(d2-c2);
       if(test.sign(test.getvalue(x1,r2)-test.getvalue(x1,l2))<0)
         c2=l2;
       else
         d2=r2;
     }
     dx2=x2-(c2+d2)/2;
     x2=(c2+d2)/2;
   }
   cout<<" : "<<x1<<"\t"<<x2<<"\t"<<test.getvalue(x1,x2)<<endl;
}

*/

/*

//  
m525 test;
double *_grad,*step,*x;
int r;

double getderive(int i,double *x)
{
  double dx=fabs(test.getmax(i)-test.getmin(i))/1000;//l=0.000001;
  int flag=0;
  double old=test.getvalue(x);
  if((x[i]+dx)>test.getmax(i)){flag=1;x[i]-=dx;} else{x[i]+=dx;flag=0;}
  double _new=test.getvalue(x);
  if(flag)x[i]+=dx;else x[i]-=dx;
  return (_new-old)/dx;
}

 void grad(double *x)
{for(int i=0;i<r;i++) _grad[i]=getderive(i,x); }

double norm(void)
{
  double sum=0;
  for(int i=0;i<r;i++) sum+=_grad[i]*_grad[i];
  for(i=0;i<r;i++)   _grad[i]/=sqrt(sum);
  return (sum);
}
    

void main(void)
{
  double e=0.00001,cons,old,_new;
  r=test.getrange();
  _grad=new double[r];
  step=new double[r];
  x=new double[r];
  for(int i=0;i<r;i++)
  {
    x[i]=(test.getmax(i)+test.getmin(i))/2;
    step[i]=fabs(x[i])/100;
  }
  int j=1;
  do
  {
    grad(x);
    cons=norm();
    old=test.getvalue(x);
    for(i=0;i<r;i++)
      if((x[i]+step[i]*_grad[i])>=test.getmin(i)&&(x[i]+step[i]*_grad[i])<=test.getmax(i))
        x[i]+=-step[i]*_grad[i];
    _new=test.getvalue(x);
    for(i=0;i<r;i++)
      step[i]/=j;
    j+=0.1;
  }while(cons>e);
  for(i=0;i<r;i++)
    cout<<x[i]<<"\t";
  cout<<(_new+old)/2<<endl;
  delete _grad;
  delete x;
  delete step;
}

*/
