#include <iostream.h>
#include <values.h>
#include <math.h>
#include <bwcc.h>

//  

class m521
{
  double min,max;
 public:
  m521(){min=0;max=15;};    //
  double getvalue(double);
  int sign(double x)
  {
    if(x>=0)
      return 1;
    return -1;
  }
  double getmax(){return max;};
  double getmin(){return min;};
  void setmax(double d){max=d;};
  void setmin(double d){min=d;};
};


double m521::getvalue(double x)
{
  if(x>max||x<min)
  {
    BWCCMessageBox(0," getvalue","   ",MB_OK);
    return MAXDOUBLE;
  }
  return (27.0-2*x*(9.0-x))*exp(-x/3.0);
}


class m522
{
  double min,max;
 public:
  m522(){min=0;max=15;};    //
  double getvalue(double);
  int sign(double x)
  {
    if(x>=0)
      return 1;
    return -1;
  }
  DWORD fib(int);
  double getmax(){return max;};
  double getmin(){return min;};
  void  setmax(double d){max=d;};
  void  setmin(double d){min=d;};
};

DWORD m522::fib(int num)//c 0;
{
  if(num==0||num==1)
    return 1;
  DWORD fpred=1,fpredpred=1,fcur;
  for(int i=2;i<=num;i++)
  {
    fcur=fpred+fpredpred;
    fpredpred=fpred;
    fpred=fcur;
  }
  return fcur;
}


double m522::getvalue(double x)
{
  if(x>max||x<min)
  {
    BWCCMessageBox(0," getvalue","   ",MB_OK);
    return MAXDOUBLE;
  }
  return (27.0-2*x*(9.0-x))*exp(-x/3.0);
}


class m523
{
  double min,max;
 public:
  m523(){min=0;max=15;};    //
  int sign(double x)
  {
    if(x>=0)
      return 1;
    return -1;
  }
  double getvalue(double);
  double getmax(){return max;};
  double getmin(){return min;};
  void  setmax(double d){max=d;};
  void  setmin(double d){min=d;};
};


double m523::getvalue(double x)
{
  if(x>max||x<min)
  {
    BWCCMessageBox(0," getvalue","   ",MB_OK);
    return MAXDOUBLE;
  }
  return (27.0-2*x*(9.0-x))*exp(-x/3.0);
}


class m524
{
  double minx1,maxx1,minx2,maxx2;
 public:
  m524(){minx1=-1;maxx1=0;minx2=0;maxx2=1;};    //
  double getvalue(double,double);
  double getmaxx1(){return maxx1;};
  double getminx1(){return minx1;};
  int sign(double x)
  {
    if(x>=0)
      return 1;
    return -1;
  }
  void  setmaxx1(double d){maxx1=d;};
  void  setminx1(double d){minx1=d;};
  double getmaxx2(){return maxx2;};
  double getminx2(){return minx2;};
  void  setmaxx2(double d){maxx2=d;};
  void  setminx2(double d){minx2=d;};
};


double m524::getvalue(double x1,double x2)
{
  if(x1>maxx1||x1<minx1||x2>maxx2||x2<minx2)
  {
    BWCCMessageBox(0," getvalue","   ",MB_OK);
    return MAXDOUBLE;
  }
  return exp(x1*x1+x2*x2)+2*x1-3.5*x2;
}


class m525
{
  double minx1,maxx1,minx2,maxx2;
  int r;
 public:
  m525(){minx1=-1;maxx1=0;minx2=0;maxx2=1;r=2;};    //
  double getvalue(double*);
  int getrange(){return r;};
  double getmax(int);
  double getmin(int);
  void setmax(int,double d);
  void setmin(int,double d);
  int sign(double x)
  {if(x>=0) return 1;return -1;}
};

void m525::setmax(int i,double d)
{ if(!i) maxx1=d;  else maxx2=d;}

void m525::setmin(int i,double d)
{if(!i) minx1=d; else minx2=d;
}

double m525::getmax(int i)
{if(!i) return maxx1;  return maxx2;}

double m525::getmin(int i)
{
  if(!i) return minx1; return minx2;}

double m525::getvalue(double *x)
{
  if(x[0]>maxx1||x[0]<minx1||x[1]>maxx2||x[1]<minx2)
  {
    BWCCMessageBox(0," getvalue","   ",MB_OK);
    return MAXDOUBLE;
  }
  return exp(x[0]*x[0]+x[1]*x[1])+2*x[0]-3.5*x[1];
}


class m526
{
  double minx1,maxx1,minx2,maxx2;
 public:
  m526(){minx1=-1;maxx1=0;minx2=0;maxx2=1;};    //
  double getvalue(double,double);
  int sign(double x)
  {
    if(x>=0)
      return 1;
    return -1;
  }
  double getmaxx1(){return maxx1;};
  double getminx1(){return minx1;};
  void  setmaxx1(double d){maxx1=d;};
  void  setminx1(double d){minx1=d;};
  double getmaxx2(){return maxx2;};
  double getminx2(){return minx2;};
  void  setmaxx2(double d){maxx2=d;};
  void  setminx2(double d){minx2=d;};
};


double m526::getvalue(double x1,double x2)
{
  if(x1>maxx1||x1<minx1||x2>maxx2||x2<minx2)
  {
    BWCCMessageBox(0," getvalue","   ",MB_OK);
    return MAXDOUBLE;
  }
  return exp(x1*x1+x2*x2)+2*x1-3.5*x2;
}



