#if !defined(Collect_H)
#define Collect_H

#include <StdDef.h>
#include <Mem.h>
#include <a-Util.h>
#include <AnObject.h>

template <class Type>
class Callection: public AnObject
	{
	public:
		Callection(int ,int );
		virtual ~Callection();
		virtual void shutDown();
		Type *at(int);
		virtual int indexOf( Type *item );
		void atFree( int index );
		void atRemove( int index );
		void remove( Type *item );
		void removeAll();
		void free( Type *item );
		void freeAll();
		void atInsert( int index, Type *item );
		void atPut( int index, Type *item );
		virtual int insert( Type *item );
		static void error( int code, int info );
		Type *firstThat( Bool (* Test)(Type *,void *), void *arg );
		Type *lastThat( Bool (* Test)(Type *,void *), void *arg );
		void forEach( void (* Exec)(Type *,void *), void *arg );
		void pack();
		virtual void setLimit( int aLimit );
		int getCount()
			{ return count; }
	protected:
		Type **items;
		int count;
		int limit;
		int delta;
		Bool shouldDelete;
	private:
		virtual void freeItem( Type *item );
	};

typedef Callection<void> vCollection;

template<class Type>
class SortedCollection:public Callection<Type>
      {
      protected:
	   virtual int compare(Type * i1,Type * i2)=0;
	   Bool    enableDuplicates;
      public:
	   SortedCollection(int a,int b):Callection<Type>(a,b)
		{
		enableDuplicates=True;
		}
	   virtual int insert(Type * t);
      };

#endif