#if !defined(Points_H)
#define  Points_H

#include <a-Util.h>

class Point
	{
	public:
		int x,y;

		Point():x(0),y(0) {;}
		Point(int X,int Y):x(X),y(Y) {;}
		Point(Point& p) {x=p.x;y=p.y;}

		Point& operator = (Point& p) {x=p.x;y=p.y;return *this;}
		Point& operator = (int i) {x=y=i; return *this;}

		Point& operator += (Point& p) {x+=p.x;y+=p.y;return *this;}
		Point& operator -= (Point& p) {x-=p.x;y-=p.y;return *this;}

		Bool operator == (Point& p) { return Bool((x==p.x)&&(y==p.y)); }
		Bool operator != (Point& p) { return Bool((x!=p.x)||(y!=p.y)); }
	};

inline Point operator + (Point& a,Point& b)
	{
	return Point(a.x+b.x,a.y+b.y);
	}
inline Point operator - (Point& a,Point& b)
	{
	return Point(a.x-b.x,a.y-b.y);
	}
inline Point operator - (Point& p)
	{
	return Point(-p.x,-p.y);
	}

class Rect
	{
	public:
		Point a,b;

		Rect() {;}
		Rect(Point& A,Point& B):a(A),b(B) {;}
		Rect(int l,int t,int r,int b):a(l,t),b(r,b) {;}
		Rect(Rect& r): a(r.a),b(r.b) {;}

		Rect& operator = (Rect& r) { a=r.a;b=r.b; return *this; }
		Rect& operator += (Point& p) {a+=p;b+=p; return *this; }
		Rect& operator -= (Point& p) {a-=p;b-=p; return *this; }

		Bool operator & (Point& p)
			{
			return Bool((a.x<=p.x)&&(p.x<b.x)&&(a.y<=p.y)&&(p.y<b.y));
			}

		Rect& operator ^= (Rect& r)
			{
			a.x=Max(a.x,r.a.x);
			a.y=Max(a.y,r.a.y);
			b.x=Min(b.x,r.b.x);
			b.y=Min(b.y,r.b.y);
			return *this;
			}
	};

inline Rect operator + (Rect& r,Point& p)
	{
	return Rect(r.a+p,r.b+p);
	}

inline Rect operator - (Rect& r,Point& p)
	{
	return Rect(r.a-p,r.b-p);
	}

#endif