//
//
//
#if !defined(Event_H)
#define Event_H

#include <a-Points.h>
#include <GScreen.h>

class View;
class Mouse;

const evMouseDown = 0x0001;
const evMouseUp   = 0x0002;
const evMouseMove = 0x0004;
const evMouseAuto = 0x0008;
const evKeyDown   = 0x0010;
const evCommand   = 0x0100;
const evBroadcast = 0x0200;

/* Event masks */

const evNothing   = 0x0000;
const evMouse     = 0x000f;
const evKeyboard  = 0x0010;
const evMessage   = 0xFF00;

/* Mouse button state masks */

const mbLeftButton  = 0x01;
const mbRightButton = 0x02;


struct Where
	{
	int x;
	int y;
	};

inline Point getPoint(Where& w)
	{
	return Point(w.x,w.y);
	}

struct MouseEventType
	{
	byte buttons;
	Bool doubleClick;
	Where where;
	};
struct CharScanType
	{
	byte charCode;
	byte scanCode;
	};

struct KeyDownEvent
	{
	union
		{
		word keyCode;
		CharScanType charScan;
		};
	};

struct MessageEvent
	{
	word command;
	union
		{
		void *infoPtr;
		long infoLong;
		word infoWord;
		short infoInt;
		byte infoByte;
		char infoChar;
		};
	};

struct Event
	{
	word what;
	union
		{
		MouseEventType mouse;
		KeyDownEvent keyDown;
		MessageEvent message;
		};
	View * target;
	void getMouseEvent();
	void getKeyEvent();
};

const eventQSize=32;

class EventQueue
	{
	public:
		EventQueue();
		~EventQueue();

		static void getMouseEvent( Event& );
		static void suspend();
		static void resume();

		static word near doubleDelay;
		static Bool near mouseReverse;

		static Mouse near mouse;
	      private:
		static void getMouseState( Event& );
		static void huge mouseInt();

		static void setLast( Event& );

		static MouseEventType near lastMouse;
		static MouseEventType near curMouse;

		static MouseEventType near downMouse;
		static word near downTicks;

		static word far * near Ticks;
		static Event near eventQueue[ eventQSize ];
		static Event * near eventQHead;
		static Event * near eventQTail;
		static Bool near mouseIntFlag;
		static word near eventCount;

		static Bool near mouseEvents;

		static word near repeatDelay;
		static word near autoTicks;
		static word near autoDelay;
	};

inline void Event::getMouseEvent()
	{
	EventQueue::getMouseEvent( *this );
	}

#endif
