#if !defined(Menu_H)
#define Menu_H

#include <View.H>
#include <dbg.h>

struct MenuItem
        {
        char * name;
        char * key;
        word shortKey;
        word command;
        MenuItem * next;
        Rect r;
        Bool on;

        MenuItem(char * n,char * k,word s,word c)
                {
                name=newString(n);
                key=newString(k);
                shortKey=s;command=c;
                next=0;
                r.a.x=2;r.b.x=((extStrLen(name)+strlen(key)+2)<<3)+2;
                r.a.y=2;r.b.y=16;
                on=False;
                }
        virtual ~MenuItem()
                {
                delete next;
                delete name;
                delete key;
                }
        };

class PopUp:public View
        {
        protected:
                int act;
                MenuItem * menu;
                byte normBack,normText,hiBack,hiText;
        public:
                PopUp& operator + (MenuItem * mi);
                virtual void drawMenuItem(MenuItem * mi,Bool on);
                virtual void draw();
                virtual void handle(Event& ev);
                MenuItem * at(int);
                int getCount();
                PopUp();
                virtual ~PopUp();
        };

struct SubMenu
        {
        PopUp * pu;
        char * name;
        Rect r;
        Bool on;
        word shortKey;
        SubMenu * next;
        SubMenu(char * n,word sk,word hc=0):shortKey(sk)
                {
                name=newString(n);
                on=False;
                next=0;
                if((pu=new PopUp())!=0)
                        pu->helpContext=hc;
                }
        ~SubMenu()
                {
                delete next;
                destroy(pu);
                }
        SubMenu& operator + (MenuItem* mi)
                {
                if(pu!=0) *pu+mi;
                return *this;
                }
        };

class MenuBar:public View
        {
        protected:
                byte normText,normBack,hiText,hiBack;
                SubMenu * sm;
                int a;
                Bool poped;
        public:
                virtual void draw();
                virtual void handle(Event&);
                virtual int  drawMenuItem(SubMenu * s,Bool on);
                MenuBar& operator + (SubMenu& s);
                MenuBar(Rect& r);
                SubMenu * at(int);
                int getCount();
                virtual ~MenuBar();
                void endModal(word);
        };

#endif
