#if !defined(ScrollBar_H)
#define ScrollBar_H

#include <View.H>

const cmValueChanged=1100,cmAutoScroll=1101;

class ScrollBar:public View
	{
	protected:
		int value;
		int page;
		int limit;
		word chars[3];
		word keys[4];
		Point oldMouse;
		Bool  locked;
	public:
		int getValue() const { return value; }
		int getLimit() const { return limit; }
		int getPage()  const { return page;  }
		virtual void setValue(int );
		virtual void setLimit(int );
		virtual void setPage(int );
	protected:
		void up()   { setValue(value-1); command(cmValueChanged); }
		void down() { setValue(value+1); command(cmValueChanged); }
		void pgUp() { setValue(value-page); command(cmValueChanged); }
		void pgDn() { setValue(value+page); command(cmValueChanged); }

		void command(int );

		virtual void Drag(Point& p)=0;

		virtual Rect upRect()=0;
		virtual Rect dnRect()=0;
		virtual Rect btRect()=0;
		virtual Rect puRect()=0;
		virtual Rect pdRect()=0;
	public:
		ScrollBar(Rect& r,int l=1,int v=0);
		virtual void draw();
		virtual void handle(Event& ev);
	};

class VScrollBar:public ScrollBar
	{
	protected:
		virtual void Drag(Point& p);

		virtual Rect upRect();
		virtual Rect dnRect();
		virtual Rect btRect();
		virtual Rect puRect();
		virtual Rect pdRect();
	public:
		VScrollBar(Rect& r,int l=1,int v=0);
	};

class HScrollBar:public ScrollBar
	{
	protected:
		virtual void Drag(Point& p);

		virtual Rect upRect();
		virtual Rect dnRect();
		virtual Rect btRect();
		virtual Rect puRect();
		virtual Rect pdRect();
	public:
		HScrollBar(Rect& r,int l=1,int v=0);
	};

#endif