//
//
//
#if !defined(GV_View_H)
#define GV_View_H

#include <a-Points.H>
#include <AnObject.H>
#include <gvConst.H>
#include <grMouse.H>
#include <Event.H>

class far Program;

class View:public AnObject
        {
        protected:
                static Program * application;
        public:
                Point cursor;
                byte  dragMode,growMode;
                word  eventMask;
                word  helpContext;
                word  options,state;
                Point origin,size;
                Rect  clip;
                View * owner;
                View * next;
                View * current;

                byte * palette;

                word endState;

        public:
                View(Rect& r);
                virtual ~View(){;}
                virtual void shutDown();

                void insertView(View *);
                virtual void insert(View *);
                void removeView(View *);
                virtual void remove(View *);

                virtual void changeBounds(Rect& r);
                virtual void fitBounds();

                void clearEvent(Event&);
                virtual void getEvent(Event&);
                virtual void putEvent(Event&);

//              Bool getKeyEvent(KeyDownEvent&);
//              Bool getMooseEvent(MooseEvent&);
//              Bool getCommand(Event&);
                void putCommand(word,View*);

		Bool containsMoose(Event&,Point&);

                virtual void drawCursor();
                void hideCursor();
                void showCursor();

                void show();
                void hide();

                word drawGroup();
                virtual void draw();
                void redraw();

                word execView(View*);
                virtual word execute();
                virtual void endModal(word);
                virtual Bool valid(word);

                virtual Rect workSpace();
                virtual word getHelpCtx();

                virtual void handle(Event&);
                void makeGlobal(Rect&);
                void makeLocal(Point&);

                View * prev();

                void makeFirst(View *);
                void scrollFirst(View *);
                virtual void select();
                virtual void selectView(View*);
                virtual void unselect();
                void unselectView(View*);
                void selectNext();
                void selectPrev();

                virtual void sizeLimit(Point&);

                virtual byte getColor(int);

                void setcolor(int i);
                void setfillstyle(int,int);
                void line(int,int,int,int);
                void rectangle(int,int,int,int);
                void bar(int,int,int,int);
                void putpixel(int,int,int);
                void outtextxy(int,int,char*);
                void writeText(int x,int y,char * s,int c1,int c2,Bool underline=False);
        };

int extStrLen(char *);

#endif
