#include <owl\applicat.h>
#include <owl\framewin.h>
#include <owl\scroller.h>
#include <owl\point.h>
#include <owl\dc.h>
#include <owl\metafile.h>


class TScrollWin: public TFrameWindow
{
public:
  TScrollWin(TWindow* parent, const char far* title);
protected:
  void SetupWindow();
  void Paint(TDC& dc, BOOL erase, TRect& rect);
  DECLARE_RESPONSE_TABLE(TScrollWin);
};


DEFINE_RESPONSE_TABLE1(TScrollWin, TFrameWindow)
  EV_COMMAND(200,CmExit),
END_RESPONSE_TABLE;


TScrollWin::TScrollWin(TWindow* parent, const char far* title)
  : TFrameWindow(parent, title),	 TWindow(parent, title)
{
  Attr.Style |= WS_VSCROLL | WS_HSCROLL;
  Scroller = new TScroller(this, 0, 0, 0, 0);
}


void TScrollWin::SetupWindow()
{
  TFrameWindow::SetupWindow();
  TClientDC dc(*this);
  TSize increment = dc.GetTextExtent((LPSTR)"M", 1);
  increment.cy *= 2;  // Double-spaced lines
  Scroller->SetUnits(increment.cx, increment.cy);
  Scroller->SetRange(increment.cx*250,increment.cy*1000);
}

void TScrollWin::Paint(TDC& dc, BOOL /*erase*/, TRect& /*rect*/)
{
  dc.PlayMetaFile(TMetaFilePict(_argv[1]));
}


class TScrollApp: public TApplication
{
 public:
  TScrollApp(const char far* name) : TApplication(name) {};
  void InitMainWindow()
  {
	 MainWindow = new TScrollWin(0, "");
  }
};

int OwlMain(int argc, char**)
{
  return TScrollApp("Viewer").Run();
}


