#include <classlib\assoc.h>
#include <classlib\arrays.h>
#include <classlib\dict.h>
#include <classlib\objstrm.h>
#include <cstring.h>
#include <conio.h>

#define BUF_LEN 80

// -  ,   : , 
_CLASSDEF(IntDWORD)
class IntDWORD
{
  DWORD code;//
 public:
  IntDWORD(DWORD c=0xffffffffL):code(c){};
  DWORD getcode() const{return code;};//- 
  void setcode(DWORD c){code=c;};
  void setready(DWORD flag)//or 1 or 0
  {
	 if(flag){flag<<=31;code|=flag;}
	 else{flag=1;flag<<=31;code&=~flag;}
  }//      
  void setreit(DWORD flag)
  {
	 if(flag){flag<<=30;code|=flag;}
	 else{flag=1;flag<<=30;code&=~flag;}
  }
  DWORD getready(){ return code>>31; }// 
  DWORD getreit() { return (code<<1)>>31; }
  friend ostream& operator<<(ostream &os,IntDWORD &dw);
  friend istream& operator>>(istream &is,IntDWORD &dw);
  virtual unsigned HashValue() const {return (unsigned)code;};
  int operator==(IntDWORD dw)    const
  {	 if(dw.getcode()==getcode()) return 1; else return 0; }
};

union convert1
{
  unsigned char sb[2];
  WORD dw;
};

union convert2
{
  unsigned char sb[4];
  DWORD dw;
};

ostream& operator<<(ostream &os,IntDWORD &dw)
{
  convert2 a;
  a.dw=dw.code;
  os.write(a.sb,4);
  return os;
}

istream& operator>>(istream &is,IntDWORD &dw)
{
  convert2 a;
  is.read(a.sb,4);
  dw.code=a.dw;
  return is;
}


typedef TMDDAssociation<IntDWORD,IntDWORD,TStandardAllocator> Association;
typedef TMDictionaryAsHashTableIterator<Association,TStandardAllocator> ContainerIterator;
typedef TMDictionaryAsHashTable<Association,TStandardAllocator> TSpravDict;
typedef TMArrayAsVector<string,TStandardAllocator> TStringArray;


istream &operator>>(istream &is,TSpravDict &cl)
{
  WORD Numstr;
  DWORD a,b;

  convert1 aa;
  is.read(aa.sb,2);
  Numstr=aa.dw;
  for(int i=0;i<Numstr;i++)
  {
	 convert2 aa;
	 is.read(aa.sb,4);
	 a=aa.dw;
	 is.read(aa.sb,4);
	 b=aa.dw;
	 cl.Add(*new Association(*new IntDWORD(a),*new IntDWORD(b)));
  }
  return is ;
}


ostream &operator<<(ostream &os,TSpravDict &cl)
{
  WORD num=cl.GetItemsInContainer();
  convert1 a;
  a.dw=num;
  os.write(a.sb,2);
  ContainerIterator c=cl;
  for(;int(c);)
  {
	 convert2 cnv;
	 Association &as=(Association&)c++;
	 IntDWORD a=(IntDWORD&)as.Key();
	 cnv.dw=a.getcode();
	 os.write(cnv.sb,4);
	 IntDWORD b=(IntDWORD&)as.Value();
	 cnv.dw=b.getcode();
	 os.write(cnv.sb,4);
  }
  return os ;
}


/*
//    (  - )
_CLASSDEF(TStringArray)
class TStringArray : public Array//, public TStreamable
{
  WORD code;//  -  ,    
//  virtual const char* streamableName() const
  //	 { return "TStringArray"; }
 public:
  TStringArray(WORD c,int upper, int lower = 0, sizeType aDelta = 0)
	 : Array(upper, lower, aDelta) , code(c) {};
//  virtual classType isA() const { return __firstUserClass + 1; }
//  virtual char* nameOf() const { return "TStringArray"; }
  //static PTStreamable build();
  WORD getcode(){return code;};//- 
  void setcode(WORD c){code=c;};
  friend ostream& operator<<(ostream&,TStringArray&);//
  friend istream& operator>>(istream&,TStringArray&);
  //TStringArray(StreamableInit) : Array(15, 0, 15) {};
//  virtual void write( opstream& );///   
//  virtual void* read( ipstream& );
};
*/

istream& operator >> ( istream &is, TStringArray &cl )
{
//  cl.read(is);
  WORD Numstr;
  char str[BUF_LEN+2];
  unsigned char b[2];

  //is>>code;
  is.read(str,sizeof(WORD));
  //is>>Numstr;
  convert1 a;
  is.read(a.sb,2);
  Numstr=a.dw;
  for(int i=0;i<Numstr;i++)
  {
	 is.read(b,1);
	 is.read(str,(WORD)b[0]);
	 str[(WORD)b[0]]=0;
	 //is.readString(str,BUF_LEN+1);
	 str[BUF_LEN+1]=0;
	 OemToAnsiBuff(str,str,BUF_LEN+1);
	 cl.Add(*new string(str));
  }
  return is ;//>> (RTStreamable)cl;
}


ostream &operator << ( ostream &os, TStringArray &cl )
{
//  cl.write(os);
  WORD num=cl.GetItemsInContainer();
  char str[BUF_LEN+2];
  unsigned char b[2];

  //os<<code
  //<<num;
  os.write(str,sizeof(WORD));
  convert1 a;
  a.dw=num;
  os.write(a.sb,2);
  for(int i=0;i<num;i++)
  {
	 strcpy(str,cl[i].c_str());
	 AnsiToOemBuff(str,str,BUF_LEN+1);
	 b[0]=(unsigned char)strlen(str);
	 os.write(b,1);
	 os.write(str,(WORD)b[0]);
	 //os.fwriteString(str);
  }
  return os ;//<< (RTStreamable)cl;
}


void main(void)
{
/*
  IntDWORD a=1234,b=74378L;
  ofstream f="0.1";//,ios::binary|ios::out);
  f<<a<<b;
  f.close();
  cout<<a.getcode()<<"\t"<<b.getcode()<<endl;
  IntDWORD c,d;
  ifstream f1="0.1";//,ios::binary|ios::in);
  f1>>c>>d;
  f1.close();
  cout<<c.getcode()<<"\t"<<d.getcode()<<endl<<sizeof(DWORD)<<endl;
  Association as(*new IntDWORD(a.getcode()),*new IntDWORD(b.getcode()));
  cout<<as.Key().getcode()<<"\t"<<as.Value().getcode()<<endl;
  TSpravDict spr;
  randomize();
  //for(int j=0;j<random(1000);j++)
	 //spr.Add(*new Association(*new IntDWORD(random(2000)),*new IntDWORD(35698L)));//12
  spr.Add(*new Association(*new IntDWORD(123),*new IntDWORD(456)));
  spr.Add(*new Association(*new IntDWORD(456),*new IntDWORD(123)));
  spr.Add(*new Association(*new IntDWORD(789),*new IntDWORD(890)));
  spr.Add(*new Association(*new IntDWORD(012),*new IntDWORD(567)));
  spr.Add(*new Association(*new IntDWORD(345),*new IntDWORD(234)));
  spr.Add(*new Association(*new IntDWORD(678),*new IntDWORD(901)));
  spr.Add(*new Association(*new IntDWORD(901),*new IntDWORD(678)));
  spr.Add(*new Association(*new IntDWORD(234),*new IntDWORD(345)));
  spr.Add(*new Association(*new IntDWORD(567),*new IntDWORD(012)));
  spr.Add(*new Association(*new IntDWORD(890),*new IntDWORD(789)));
  spr.Add(*new Association(*new IntDWORD(1231),*new IntDWORD(4561)));
  spr.Add(*new Association(*new IntDWORD(1232),*new IntDWORD(4562)));
  spr.Add(*new Association(*new IntDWORD(1233),*new IntDWORD(4563)));
  spr.Add(*new Association(*new IntDWORD(1234),*new IntDWORD(4564)));
  ofstream f="_._";
  f<<spr;
  f.close();
  TSpravDict spr2;
  ifstream ff="_._";
  ff>>spr2;
  ff.close();
  ContainerIterator c=spr2;
  for(int i=0;int(c);i++)
  {
	 Association as=c++;
	 //cout<<as.Key().getcode()<<"\t"<<as.Value().getcode()<<endl;
  }
  cout<<"Gypotetic in 1:"<<spr.GetItemsInContainer()<<" real :"<<i<<endl;
  getch();
  ContainerIterator c2=spr2;
  for(i=0;int(c2);i++)
  {
	 Association as=c2++;
	 cout<<as.Key().getcode()<<"\t"<<as.Value().getcode()<<endl;
  }
  cout<<"Gypotetic in 2:"<<spr2.GetItemsInContainer()<<" real :"<<i<<endl;
  int ch=1;
  for(;ch;)
  {
	 cout<<" : ";
	 cin>>ch;
	 Association *tofind=spr2.Find(Association(IntDWORD(ch),IntDWORD(0)));
	 if( tofind == 0 )
		  cout << "A definition for " << ch
				 << " was not found in the dictionary.\n";
	 else
		  cout<<"!!!!!!!!!"<<(tofind->Key()).getcode()<<" : "<<
		  (tofind->Value()).getcode()<<endl;
  }
  */
  TStringArray arr(1,0,20);
  arr.Add(*new string(" !"));
  arr.Add(*new string(" -  ???"));
  arr.Add(*new string(" -  ..."));
  arr.Add(*new string(" -  !!!"));
  arr.Add(*new string(" # 5"));
  arr.Add(*new string(" # 6"));
  arr.Add(*new string(" # 7"));
  arr.Add(*new string(" # 8"));
  arr.Add(*new string(" # 9"));
  arr.Add(*new string(" #10"));
  arr.Add(*new string(" #11"));
  arr.Add(*new string(" #12"));
  arr.Add(*new string(" #13"));
  arr.Add(*new string(" #14"));
  arr.Add(*new string(" #15"));
  arr.Add(*new string(" #16, end."));
  /*
  ofstream fp("123.xls",ios::out|ios::binary);
  fp<<arr;
  fp.close();
  for(i=0;i<arr.GetItemsInContainer();i++)
	 cout<<arr[i].c_str()<<endl;
  getch();
  cout<<"\n Was read:\n";
  TStringArray arr2(1,0,20);
  ifstream fp2("123.xls",ios::in|ios::binary);
  fp2>>arr2;
  fp2.close();
  for(i=0;i<arr2.GetItemsInContainer();i++)
	 cout<<arr2[i].c_str()<<endl;
  */
  TSpravDict spr;
  ifstream ff("urok.spr",ios::in|ios::binary);
  ff>>spr;
  ff.close();
  ContainerIterator c=spr;
  for(int i=0;int(c);i++)
  {
	 Association as=c++;
	 cout<<as.Key().getcode()<<"\t"<<as.Value().getcode()<<endl;
  }
  for(int ch=1;ch;)
  {
	 cout<<" : ";
	 cin>>ch;
	 Association *tofind=spr.Find(Association(IntDWORD(ch),IntDWORD(0)));
	 if( tofind == 0 )
		  cout << "A definition for " << ch
				 << " was not found in the dictionary.\n";
	 else
	 {
		  cout<<"!!!!!!!!!"<<(tofind->Key()).getcode()<<" : "<<
		  (tofind->Value()).getcode()<<endl;
		  TStringArray arr(1,0,20);
		  ifstream f("urok.txt",ios::in|ios::binary);
		  f.seekg((tofind->Value()).getcode(),ios::beg);
		  f>>arr;
		  for(int i=0;i<arr.GetItemsInContainer();i++)
		  {
			 cout<<arr[i].c_str()<<endl;
			 getch();
		  }
	 }
  }
  ofstream file("urok.txt",ios::app|ios::binary);
  file.seekp(0,ios::end);
  DWORD offset=file.tellp();
  file<<arr;
  file.close();
  spr.Add(*new Association(*new IntDWORD(666),*new IntDWORD(offset)));
  ofstream ff_1("urok.spr",ios::out|ios::binary);
  ff_1<<spr;
  ff_1.close();
  ContainerIterator cc=spr;
  for(i=0;int(cc);i++)
  {
	 Association as=cc++;
	 cout<<as.Key().getcode()<<"\t"<<as.Value().getcode()<<endl;
	 getch();
  }








}

