#define STRICT

#ifndef __FSTREAM_H
#include <fstream.h>
#endif
#ifndef __MATH_H
#include <math.h>
#endif
#ifndef __BWCC_H
#include <bwcc.h>
#endif
#ifndef __STRING_H
#include <string.h>
#endif

#ifndef __PREDLIST_H
#include "predlist.h"
#endif
#ifndef __JURNAL_H
#include "jurnal.h"
#endif


extern TPredList pl;
extern HWND HWind;
extern n2 stud_code;

int Jurnal::getocenka(n2 student,n1 urok)
{
  DWORD offset_grup;
  BYTE GRUP_NUMBER=student.code.grup;
  BYTE STUD_NUMBER=student.code.stud;
  offset_grup=(STUD_COUNT*(STUD_NAME_LEN+sizeof(w))+GRUP_NAME_LEN)*
			 GRUP_NUMBER;
  DWORD offset_stud=offset_grup+STUD_NUMBER*(STUD_NAME_LEN+sizeof(w))+
			 GRUP_NAME_LEN+STUD_NAME_LEN;
  ifstream f(filename,ios::in|ios::binary);
  if(!f)
  {
	 MessageBox(0,"    jurnal.txt",0,
			MB_OK|MB_ICONEXCLAMATION|MB_TASKMODAL);
	 return -1;
  }
  f.seekg(offset_stud,ios::beg);
  f.read((unsigned char*)w,sizeof(w));
  f.close();
  n1 temp=urok;
  WORD s=0,notpust=0,i,j;
  if(temp.code.tema==0xf)//if ocenka po prerdm
  {
	 if(!pl.IsPredEmpty(temp))//if tem in predm
	 {
		for(temp.code.tema=0,s=0,notpust=0;temp.code.tema<TEMA_COUNT;
				temp.code.tema+=1)
		  if(!pl.IsTemaEmpty(temp))//if tem not pusto
		  {
	  for(temp.code.urok=0;temp.code.urok<UROK_COUNT;
	        temp.code.urok+=1)
	    if(!pl.IsUrokEmpty(temp))//if tests present
   	    {
	       notpust++;
               DWORD f=F<<(2*temp.code.urok);
               s+=(w[temp.code.pred][temp.code.tema]&f)>>(2*temp.code.urok);
	    } //if urok
	}     //if tema
	 }//if predm no pusto
    else//if predm pustoy
      return -1;
    if(!notpust) return -1;
    return  ceil(double(s)/double(notpust));
  }//if ocenka po predm
  if(temp.code.urok==0xf)  //  
  {
    if(!pl.IsTemaEmpty(temp))//if tema not pusto
    {
      for(temp.code.urok=0,notpust=0,s=0;temp.code.urok<UROK_COUNT;temp.code.urok+=1)
        if(!pl.IsUrokEmpty(temp))//if not pusto
		  {
	  notpust++;
	  DWORD f=F<<(2*temp.code.urok);
	  s+=(w[temp.code.pred][temp.code.tema]&f)>>(2*temp.code.urok);
	}       //if urok
     }
     else
       return -1;//if tema pusto
     if(!notpust)
       return -1;
	  return ceil(double(s)/double(notpust));
  }     //if tema
  //ocenka po uroku
  if(!pl.IsUrokEmpty(temp))
  {//  
    DWORD ff=F<<(2*urok.code.urok);
    return (w[urok.code.pred][urok.code.tema]&ff)>>(2*urok.code.urok);
  }
  return -1;
}


void Jurnal::putocenka(n2 student,n1 urok,DWORD ocenka)
{
  DWORD offset_grup;
  BYTE GRUP_NUMBER=student.code.grup;
  BYTE STUD_NUMBER=student.code.stud;
  offset_grup=(STUD_COUNT*(STUD_NAME_LEN+sizeof(w))+GRUP_NAME_LEN)*
	       GRUP_NUMBER;
  DWORD offset_stud=offset_grup+STUD_NUMBER*(STUD_NAME_LEN+sizeof(w))+
		    GRUP_NAME_LEN+STUD_NAME_LEN;
  fstream ff(filename,ios::in|ios::out|ios::binary);
  if(!ff)
  {
    MessageBox(0,"    jurnal.txt",0,
		   MB_OK|MB_ICONEXCLAMATION|MB_TASKMODAL);
    return ;
  }
  ff.seekg(offset_stud,ios::beg);
  ff.read((unsigned char*)w,sizeof(w));
  DWORD f=F<<(2*urok.code.urok);
  f=~f;
  ocenka<<=(2*urok.code.urok);
  w[urok.code.pred][urok.code.tema]=(w[urok.code.pred][urok.code.tema]&f)|ocenka;
  ff.seekp(offset_stud,ios::beg);
  ff.write((unsigned char*)w,sizeof(w));
  ff.close();
}


Jurnal::Jurnal(char *name)
{
  strcpy(filename,name);//   
  ifstream f=filename;
  if(!f)//     
  {
	 createfile();
	 BWCCMessageBox(0,"   ",0,MB_OK|
			MB_ICONEXCLAMATION|MB_TASKMODAL);
	 return;
  }
  else
	 f.close();
}


void Jurnal::createfile()
{
  ofstream f(filename,ios::out|ios::binary);
  if(!f)
  {
		MessageBox(0,"   ",0,MB_OK|
			MB_ICONEXCLAMATION|MB_TASKMODAL);
	 return;
  }
  DWORD offset=(STUD_COUNT*(STUD_NAME_LEN+sizeof(w))+
			GRUP_NAME_LEN)*GRUP_COUNT;
  for(DWORD i=0;i<offset;i++)
	 f.write("\0",1);
  f.close();
}


void Jurnal::clearlist(void)
{
  SendDlgItemMessage(HWind,LISTBOX,LB_RESETCONTENT,0,0L);
}


void Jurnal::setgrupname(n2 code,char *name)
{
  if(strlen(name)>GRUP_NAME_LEN)
  {
	 MessageBox(0,"  ","",MB_OK|MB_ICONSTOP|MB_TASKMODAL);
	 return;
  }
  strcpy(grup_name,name);
  for(int i=strlen(grup_name);i<PRED_NAME_LEN;grup_name[i++]=0);
  DWORD offset_grup;
  BYTE GRUP_NUMBER=code.code.grup;
  offset_grup=(STUD_COUNT*(STUD_NAME_LEN+sizeof(w))+GRUP_NAME_LEN)*
					GRUP_NUMBER;
  fstream f(filename,ios::in|ios::out|ios::binary);
  if(!f)
  {
	 MessageBox(0,"    jurnal.txt",0,
			MB_OK|MB_ICONHAND|MB_TASKMODAL);
	 return;
  }
  f.seekp(offset_grup,ios::beg);
  AnsiToOemBuff(grup_name,grup_name,GRUP_NAME_LEN);
  f.write(grup_name,GRUP_NAME_LEN);
  f.close();
}


void Jurnal::setstudname(n2 code,char *name)
{
  if(strlen(name)>STUD_NAME_LEN)
  {
	 MessageBox(0,"  ","",MB_OK|MB_ICONSTOP|MB_TASKMODAL);
	 return;
  }
  strcpy(stud_name,name);
  for(int i=strlen(stud_name);i<TEMA_NAME_LEN;stud_name[i++]=0);
  fstream f(filename,ios::in|ios::out|ios::binary);
  if(!f)
  {
    MessageBox(0,"    jurnal.txt",0,
		   MB_OK|MB_ICONHAND|MB_TASKMODAL);
    return;
  }
  DWORD offset_grup;
  BYTE GRUP_NUMBER=code.code.grup;
  BYTE STUD_NUMBER=code.code.stud;
  offset_grup=(STUD_COUNT*(STUD_NAME_LEN+sizeof(w))+GRUP_NAME_LEN)*
			 GRUP_NUMBER;
  DWORD offset_stud=offset_grup+STUD_NUMBER*(STUD_NAME_LEN+sizeof(w))+
			 GRUP_NAME_LEN;
  f.seekp(offset_stud,ios::beg);
  AnsiToOemBuff(stud_name,stud_name,STUD_NAME_LEN);
  f.write(stud_name,STUD_NAME_LEN);
  if(!strlen(name))
  {
	 f.seekp(STUD_NAME_LEN,ios::cur);
	 for(int i=0;i<PREDMET_COUNT;i++)
		for(int j=0;j<TEMA_COUNT;j++)
		  w[i][j]=0;
	 f.write((unsigned char*)w,sizeof(w));
  }
  f.close();
}


char *Jurnal::getgrupname(n2 code)
{
  DWORD offset_grup;
  BYTE GRUP_NUMBER=code.code.grup;
  offset_grup=(STUD_COUNT*(STUD_NAME_LEN+sizeof(w))+GRUP_NAME_LEN)*
					GRUP_NUMBER;
  ifstream f(filename,ios::in|ios::binary);
  if(!f)
  {
	 MessageBox(0,"    jurnal.txt",0,
			MB_OK|MB_ICONEXCLAMATION|MB_TASKMODAL);
	 return "";
  }
  f.seekg(offset_grup,ios::beg);
  f.read(grup_name,GRUP_NAME_LEN);
  OemToAnsiBuff(grup_name,grup_name,GRUP_NAME_LEN);
  f.close();
  return grup_name;
}


char *Jurnal::getstudname(n2 code)
{
  if(code.code.grup==0xf)
  {
	 MessageBox(0,"     ",
			0,MB_OK|MB_ICONSTOP|MB_TASKMODAL);
	 return "";
  }
  DWORD offset_grup;
  BYTE GRUP_NUMBER=code.code.grup;
  BYTE STUD_NUMBER=code.code.stud;
  offset_grup=(STUD_COUNT*(STUD_NAME_LEN+sizeof(w))+GRUP_NAME_LEN)*
			 GRUP_NUMBER;
  DWORD offset_stud=offset_grup+STUD_NUMBER*(STUD_NAME_LEN+sizeof(w))+
			 GRUP_NAME_LEN;
  ifstream f(filename,ios::in|ios::binary);
  if(!f)
  {
	 MessageBox(0,"    jurnal.txt",0,
			MB_OK|MB_ICONEXCLAMATION|MB_TASKMODAL);
	 return "";
  }
  f.seekg(offset_stud,ios::beg);
  f.read(stud_name,STUD_NAME_LEN);
  OemToAnsiBuff(stud_name,stud_name,STUD_NAME_LEN);
  f.close();
  return stud_name;
}



int Jurnal::addgrup(char *name)
{
  n2 temp;
  int index=0xf,flag=0;

  if(!strlen(name)||strlen(name)>GRUP_NAME_LEN)
  {
    MessageBox(0,"     ",0,
		   MB_OK|MB_ICONSTOP|MB_TASKMODAL);
    return -1;
  }
  for(temp.code.grup=0;temp.code.grup<GRUP_COUNT;temp.code.grup+=1)
    if(!strcmp(name,getgrupname(temp)))
    {
      MessageBox(0,"  ",
			  0,MB_OK|MB_ICONINFORMATION|MB_TASKMODAL);
		return -1;
	 }
  for(temp.code.grup=0;temp.code.grup<GRUP_COUNT;temp.code.grup+=1)
	 if(!strlen(getgrupname(temp)))
    {
      index=temp.code.grup;
      flag=1;
      break;
    }
  if(!flag)
  {
    MessageBox(0,"   ","",
		   MB_OK|MB_ICONINFORMATION|MB_TASKMODAL);
    return -1;
  }
  temp.code.grup=index;
  setgrupname(temp,name);
  SendDlgItemMessage(HWind,LISTBOX,LB_DELETESTRING,(WPARAM)index,0L);
  SendDlgItemMessage(HWind,LISTBOX,LB_INSERTSTRING,(WPARAM)index,(LPARAM)
		    (int FAR*)name);
  SendDlgItemMessage(HWind,LISTBOX,LB_SETCURSEL,(WPARAM)index,0L);
  stud_code.code.grup=index;
  return index;
}


int Jurnal::addstud(n2 code,char *name)
{
  n2 temp;
  int index=0xf,flag=0;

  if(code.code.grup==0xf)
  {
    MessageBox(0,"  ",0,MB_OK|MB_ICONHAND|MB_TASKMODAL);
    return 0xf;
  }
  temp.code.grup=code.code.grup;
  if(!strlen(name)||strlen(name)>STUD_NAME_LEN)
  {
    MessageBox(0,"     ",0,
		   MB_OK|MB_ICONSTOP|MB_TASKMODAL);
    return 0xf;
  }
  for(temp.code.stud=0;temp.code.stud<STUD_COUNT;temp.code.stud+=1)
	 if(!strcmp(name,getstudname(temp)))
    {
      MessageBox(0,"  ",
		     0,MB_OK|MB_ICONINFORMATION|MB_TASKMODAL);
      return 0xf;
    }
  for(temp.code.stud=0;temp.code.stud<STUD_COUNT;temp.code.stud+=1)
    if(!strlen(getstudname(temp)))
    {
		index=temp.code.stud;
      flag=1;
      break;
    }
  if(!flag)
  {
    MessageBox(0,"   "," ",
		   MB_OK|MB_ICONINFORMATION|MB_TASKMODAL);
    return 0xf;
  }
  temp.code.stud=index;
  setstudname(temp,name);
  SendDlgItemMessage(HWind,LISTBOX,LB_DELETESTRING,(WPARAM)index,0L);
  SendDlgItemMessage(HWind,LISTBOX,LB_INSERTSTRING,(WPARAM)index,(LPARAM)
		    (int FAR*)name);
  SendDlgItemMessage(HWind,LISTBOX,LB_SETCURSEL,(WPARAM)index,0L);
  stud_code.code.stud=index;
  return index;
}


void Jurnal::delgrup(n2 code)
{
  int index=code.code.grup;

  if(!IsGrupEmpty(code))
  {
    MessageBox(0,"     ",0,
		   MB_OK|MB_ICONASTERISK|MB_TASKMODAL);
    return;
  }
  if(code.code.grup==0xf)
  {
    MessageBox(0,"  ",0,MB_OK|MB_ICONEXCLAMATION|MB_TASKMODAL);
    return;
  }
  setgrupname(code,"");
  SendDlgItemMessage(HWind,LISTBOX,LB_DELETESTRING,(WPARAM)index,0L);
  SendDlgItemMessage(HWind,LISTBOX,LB_INSERTSTRING,(WPARAM)index,(LPARAM)
		    (int FAR*)"");
}


void Jurnal::delstud(n2 code)
{
  int index=code.code.stud;

  if(code.code.grup==0xf||code.code.stud==0xf)
  {
    MessageBox(0,"  ",0,MB_OK|MB_ICONEXCLAMATION|MB_TASKMODAL);
    return;
  }
  setstudname(code,"");
  SendDlgItemMessage(HWind,LISTBOX,LB_DELETESTRING,(WPARAM)index,0L);
  SendDlgItemMessage(HWind,LISTBOX,LB_INSERTSTRING,(WPARAM)index,(LPARAM)
		    (int FAR*)"");
}


int Jurnal::IsGrupEmpty(n2 code)
{
  n2 temp;

  temp.code.grup=code.code.grup;
  for(temp.code.stud=0;temp.code.stud<STUD_COUNT;temp.code.stud+=1)
    if(strlen(getstudname(temp)))
		return 0;
  return 1;
}

